package altro.bowling;

import java.util.concurrent.locks.Condition;
import java.util.concurrent.locks.Lock;
import java.util.concurrent.locks.ReentrantLock;

public class Sala {

	// variabili di sincronizzazione
	private int num_piste;
	private boolean pista[];
	private int palleDisponibili;

	// lock e condition
	private Lock lock = new ReentrantLock();
	private Condition condition = lock.newCondition();

	public Sala(int num_piste, int num_palle) {

		this.num_piste = num_piste;
		pista = new boolean[num_piste];
		for (int i = 0; i < num_piste; i++)
			pista[i] = false;
		
		palleDisponibili = num_palle;
	}

	// con starvation
	public int richiediPista(int id_squadra, int numGiocatori) {

		lock.lock();
		int p;
		// while( non ci sono piste libere OPPURE non ci sono palline a sufficienza)
		while ((p = cercaPista()) == -1 || palleDisponibili < numGiocatori)
			try {
				condition.await();
			} catch (InterruptedException e) {
			}
			
		palleDisponibili -= numGiocatori;
		pista[p] = true;

		try {
		} finally {
			lock.unlock();
		}
		return p;
	}

	public void liberaPista(int numPista, int numGiocatori) {

		lock.lock();

		palleDisponibili += numGiocatori;
		pista[numPista] = false;

		condition.signalAll();
		
		try {
		} finally {
			lock.unlock();
		}
	}

	public int cercaPista() {

		for (int i = 0; i < num_piste; i++)
			if (!pista[i])
				return i;
		return -1;
	}
}
