package altro.bowling;

import java.util.concurrent.locks.Condition;
import java.util.concurrent.locks.Lock;
import java.util.concurrent.locks.ReentrantLock;

public class SalaNS {

	// variabili di sincronizzazione
	private int num_piste;
	private boolean pista[];
	private int palleDisponibili;

	// lock e condition
	private Lock lock = new ReentrantLock();
	private Condition condition = lock.newCondition();

	// variabili per il controllo delle condizioni di starvation
	private int prossimo_da_servire;
	private int bollino;

	public SalaNS(int num_piste, int num_palle) {

		this.num_piste = num_piste;
		pista = new boolean[num_piste];
		for (int i = 0; i < num_piste; i++)
			pista[i] = false;
		
		palleDisponibili = num_palle;
		prossimo_da_servire = 1;
		bollino = 1;
	}

	// swenza starvation
	public int richiediPista(int id_squadra, int numGiocatori) {
		
		lock.lock();
		// la squadra prende il proprio ticket
		int mioBollino = bollino++;

		// while( non ci sono piste libere OPPURE non ci sono palline a sufficenza OPPURE il ticket preso non corrisponde al prossimo da servire
		while ( cercaPista() == -1 || palleDisponibili < numGiocatori || mioBollino != prossimo_da_servire)
			try {

				System.out.println("La squadra " + id_squadra + " con "
						+ numGiocatori + " giocatori "
						+ " deve attendere il suo turno con bollino "
						+ mioBollino);
				condition.await();
			} catch (InterruptedException e) {
			}
		// fa scorrere il turno 
		prossimo_da_servire++;	
		
		// si dà la possibilità immediata di provare a giocare per il prossimo numero da servire (sull'altra pista)
		condition.signalAll();
		
		palleDisponibili -= numGiocatori;
		int p = cercaPista();
		pista[p] = true;
		
		System.out
				.println("La squadra " + id_squadra + " sulla pista " + p
						+ " con " + numGiocatori + " giocatori e bollino "
						+ mioBollino);
		try {
		} finally {
			lock.unlock();
		}
		return p;
	}

	public void liberaPista(int numPista, int numGiocatori) {

		lock.lock();

		palleDisponibili += numGiocatori;
		pista[numPista] = false;
		
		condition.signalAll();
		try {
		} finally {
			lock.unlock();
		}
	}

	public int cercaPista() {

		for (int i = 0; i < num_piste; i++)
			if (!pista[i])
				return i;
		return -1;
	}
}
